"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.envToBool = exports.reInitializePackageJson = exports.setDefaultValue = void 0;
var camelcase_1 = __importDefault(require("camelcase"));
var find_package_json_1 = __importDefault(require("find-package-json"));
var debug_1 = __importDefault(require("debug"));
var ENV_CONFIG_PREFIX = 'MONGOMS_';
var defaultValues = new Map();
function getPackageJson(directory) {
    var pjIterator = find_package_json_1.default(directory);
    return pjIterator.next().value;
}
function setDefaultValue(key, value) {
    defaultValues.set(key, value);
}
exports.setDefaultValue = setDefaultValue;
var packageJson;
function reInitializePackageJson(directory) {
    packageJson = getPackageJson(directory || process.cwd());
}
exports.reInitializePackageJson = reInitializePackageJson;
reInitializePackageJson();
/**
 * Resolve "variableName" with a prefix of "ENV_CONFIG_PREFIX"
 * @param variableName The variable to use
 */
function resolveConfig(variableName) {
    var _a, _b, _c, _d;
    return ((_d = (_a = process.env["" + ENV_CONFIG_PREFIX + variableName]) !== null && _a !== void 0 ? _a : (_c = (_b = packageJson === null || packageJson === void 0 ? void 0 : packageJson.config) === null || _b === void 0 ? void 0 : _b.mongodbMemoryServer) === null || _c === void 0 ? void 0 : _c[camelcase_1.default(variableName)]) !== null && _d !== void 0 ? _d : defaultValues.get(variableName));
}
exports.default = resolveConfig;
/**
 * Convert "1, on, yes, true" to true (otherwise false)
 * @param env The String / Environment Variable to check
 */
function envToBool(env) {
    return ['1', 'on', 'yes', 'true'].indexOf(env.toLowerCase()) !== -1;
}
exports.envToBool = envToBool;
// enable debug "MONGOMS_DEBUG" is true
if (envToBool((_a = resolveConfig('DEBUG')) !== null && _a !== void 0 ? _a : '')) {
    debug_1.default.enable('MongoMS:*');
}
//# sourceMappingURL=resolve-config.js.map